/*
 *	main.c
 *
 *	GfBAǂ
 *
 *	* Thu Oct 20 00:12:00 JST 2005 Naoyuki Sawa
 *	- 1st[XB
 *	* Fri Oct 21 04:19:00 JST 2005 Naoyuki Sawa
 *	- mark_hint()̃oOC܂B
 *	  Oo[Wł́AړL[ủ]pxɂẮAqg\ȂƂ܂B
 *	* Sun Nov 06 21:39:00 JST 2005 Naoyuki Sawa
 *	- qube_disp()ɂāÃL[uLbƌAj[Vǉ܂B
 *	- tB[hwỉE[ɃS~\Ă̂C܂B
 *	- qube_action()ɂāAĊJڒɍs悤C܂B
 *	  Hɋ󒆂ŐڒĂ܂\߂łB
 *	  ɎRֈڍŝŁÂ܂܂łقƂǋCtȂƎv܂ǁBBB
 *	- shuffle()֐̎dlύXɒǏ]܂B
 *	  Q[vCɂ͉e܂B
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#ifdef USE_MUSIC
#include "instdef2.c"
#endif /*USE_MUSIC*/

#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT2
const SPRITE sprite_table[SPRITE_COUNT] = {
#include "sprite.h"
};
#undef SPRITE_
#endif /*USE_SPRITE*/

#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	萔Ee[uEp^[
 ****************************************************************************/

// L[u]e[u                ]  E90x     E180x    E270x
//                                     Q~      OQ       PO       ~P
//                                     OP      P~       ~Q       QO
const int qube_col_ofs[/*rot*/][3] = { {0,1, 0}, { 0,0, 1}, { 1, 0,1}, {1, 1,0} };
const int qube_row_ofs[/*rot*/][3] = { {0,0,-1}, {-1,0,-1}, {-1,-1,0}, {0,-1,0} };

/* L[u(ʏ) */
const short PAT_QUBE_N[5/*F*/][3/*_[W*/] = {
	{SPR_QUBE10,SPR_QUBE11,SPR_QUBE12},
	{SPR_QUBE20,SPR_QUBE21,SPR_QUBE22},
	{SPR_QUBE30,SPR_QUBE31,SPR_QUBE32},
	{SPR_QUBE40,SPR_QUBE41,SPR_QUBE42},
	{SPR_QUBE50,SPR_QUBE51,SPR_QUBE52},
};

/* L[u(tbV) */
const short PAT_QUBE_F[5/*F*/][2/*Aj[V*/] = {
	{SPR_QUBE12,SPR_QUBE13},
	{SPR_QUBE22,SPR_QUBE23},
	{SPR_QUBE32,SPR_QUBE33},
	{SPR_QUBE42,SPR_QUBE43},
	{SPR_QUBE52,SPR_QUBE53},
};		     

/* L[u(j) */
const short PAT_QUBE_C[5/*F*/][7/*Aj[V*/] = {
	{SPR_QUBE12,SPR_QUBE14,SPR_QUBE15,SPR_QUBE16,SPR_QUBE17,SPR_QUBE18,SPR_QUBE19},
	{SPR_QUBE22,SPR_QUBE24,SPR_QUBE25,SPR_QUBE26,SPR_QUBE27,SPR_QUBE28,SPR_QUBE29},
	{SPR_QUBE32,SPR_QUBE34,SPR_QUBE35,SPR_QUBE36,SPR_QUBE37,SPR_QUBE38,SPR_QUBE39},
	{SPR_QUBE42,SPR_QUBE44,SPR_QUBE45,SPR_QUBE46,SPR_QUBE47,SPR_QUBE48,SPR_QUBE49},
	{SPR_QUBE52,SPR_QUBE54,SPR_QUBE55,SPR_QUBE56,SPR_QUBE57,SPR_QUBE58,SPR_QUBE59},
};		     

/* L[u(X^[) */
const short PAT_QUBE_E[5/*F*/][4/*Aj[V*/] = {
	{SPR_QUBE1A,SPR_QUBE1B,SPR_QUBE1C,SPR_QUBE1D},
	{SPR_QUBE2A,SPR_QUBE2B,SPR_QUBE2C,SPR_QUBE2D},
	{SPR_QUBE3A,SPR_QUBE3B,SPR_QUBE3C,SPR_QUBE3D},
	{SPR_QUBE4A,SPR_QUBE4B,SPR_QUBE4C,SPR_QUBE4D},
	{SPR_QUBE5A,SPR_QUBE5B,SPR_QUBE5C,SPR_QUBE5D},
};

/* L[u(Q[I[o[) */
const short PAT_QUBE_G[5/*F*/][2/*_[W*/] = {
	{SPR_QUBE1E,SPR_QUBE1F},
	{SPR_QUBE2E,SPR_QUBE2F},
	{SPR_QUBE3E,SPR_QUBE3F},
	{SPR_QUBE4E,SPR_QUBE4F},
	{SPR_QUBE5E,SPR_QUBE5F},
};

/* L[u(]) */
const short PAT_QUBE_R[5/*F*/][2/*_[W*/][4/*]*/] = {
	{{SPR_QUBE10,SPR_QUBE1G,SPR_QUBE1H,SPR_QUBE1I},{SPR_QUBE11,SPR_QUBE1J,SPR_QUBE1K,SPR_QUBE1L}},
	{{SPR_QUBE20,SPR_QUBE2G,SPR_QUBE2H,SPR_QUBE2I},{SPR_QUBE21,SPR_QUBE2J,SPR_QUBE2K,SPR_QUBE2L}},
	{{SPR_QUBE30,SPR_QUBE3G,SPR_QUBE3H,SPR_QUBE3I},{SPR_QUBE31,SPR_QUBE3J,SPR_QUBE3K,SPR_QUBE3L}},
	{{SPR_QUBE40,SPR_QUBE4G,SPR_QUBE4H,SPR_QUBE4I},{SPR_QUBE41,SPR_QUBE4J,SPR_QUBE4K,SPR_QUBE4L}},
	{{SPR_QUBE50,SPR_QUBE5G,SPR_QUBE5H,SPR_QUBE5I},{SPR_QUBE51,SPR_QUBE5J,SPR_QUBE5K,SPR_QUBE5L}},
};

/* X^[ */
const short PAT_STAR[6/*Aj[V*/] = {
	SPR_STAR0,SPR_STAR1,SPR_STAR2,SPR_STAR3,SPR_STAR2,SPR_STAR1,
};

/* X^[ */
const short PAT_TRAIL[8/*Aj[V*/] = {
	SPR_TRAIL0,SPR_TRAIL1,SPR_TRAIL2,SPR_TRAIL3,SPR_TRAIL4,SPR_TRAIL5,SPR_TRAIL6,SPR_TRAIL7,
};

/* qbg}[N */
const short PAT_HIT[2/*Aj[V*/] = {
	SPR_HIT0,SPR_HIT1,
};

/* _[Wg */
const short PAT_DAMAGE[4/*Aj[V*/] = {
	SPR_DAMAGE0,SPR_DAMAGE1,SPR_DAMAGE2,SPR_DAMAGE3,
};

/* ړL[ug */
const short PAT_MOVE[4/*]*/][6/*Aj[V*/] = {
	{SPR_MOVE00,SPR_MOVE01,SPR_MOVE02,SPR_MOVE03,SPR_MOVE04,SPR_MOVE05},
	{SPR_MOVE10,SPR_MOVE11,SPR_MOVE12,SPR_MOVE13,SPR_MOVE14,SPR_MOVE15},
	{SPR_MOVE20,SPR_MOVE21,SPR_MOVE22,SPR_MOVE23,SPR_MOVE24,SPR_MOVE25},
	{SPR_MOVE30,SPR_MOVE31,SPR_MOVE32,SPR_MOVE33,SPR_MOVE34,SPR_MOVE35},
};

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		if(demo_main() < 0) {
			break;
		}
		schedule(); /* gKNÂ */
		game_main();
	}

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceAppSetProcPeriod(1000 / FPS);
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceLCDDispStart();
#ifdef QUICK_REPEAT
	pcePadSetTrigMode(PP_MODE_SINGLE);
#endif /*QUICK_REPEAT*/

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
#ifdef USE_3D
	surface.zbuff = zbuff;
	render_init_3d(&render, &surface, 0, 0, 0, 0, FRONT, BACK, FOVY);
#else /*USE_3D*/
	render_init_2d(&render, &surface, 0, 0, 0, 0);
#endif /*USE_3D*/

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(9/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef USE_UFE
	/* USBt@CVXeG~[VJn܂B */
	ufe_setup(9/*PCt@CT[oڑ҂()*/);
#endif /*USE_UFE*/

#ifdef TURBO
	/* NbNEEFCgؑւ܂B */
	turbo(TURBO);
#endif /*TURBO*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_init();
#endif /*USE_GC*/

#ifdef USE_TCPIP
	/* TCP/IPvgRXC[gJn܂B */
	tcpip_start(0/*EthernethCoMobt@TCY()*/);
#endif /*USE_TCPIP*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_init(LDIRECT_INTERVAL);
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_MUSIC
	/* yCu܂B */
	music_loudness(1);
	loadInst(); /* uRandomism Zone(http://www8.plala.or.jp/randomism/)v́whFLbgver.2.10xgp */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* eNX`܂B */
#ifdef TEXTURE_LIST
	{
		typedef const unsigned char TEXTURE_DATA[];
		extern TEXTURE_DATA TEXTURE_LIST;
		texture_table_init(texture_table, sizeof texture_table / sizeof *texture_table, TEXTURE_LIST);
	}
#endif /*TEXTURE_LIST*/

#ifdef USE_SPRITE
	/* ȈՃXvCghCo܂B */
	sprite_init(&render, sprite_table, SPRITE_COUNT, texture_table, TEXTURE_COUNT);
#endif /*USE_SPRITE*/

/*{{AvP[VL̏*/
	srand(pceTimerGetCount());
	hiscore = 1000;		/* nCXRA */
	difficulty = 1;		/* ՓxI */
	qube_colors = 4;	/* L[u̐F */
	hint = 1;		/* qg̗L */
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
	music_loudness(0);
#endif /*USE_MUSIC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_free();
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_TCPIP
	/* TCP/IPvgRXC[gI܂B */
	tcpip_stop();
#endif /*USE_TCPIP*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_free();
#endif /*USE_GC*/

#ifdef USE_UFE
	/* USBt@CVXeG~[VI܂B */
	ufe_stop();
#endif /*USE_UFE*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int x __attribute__((unused));
	int y __attribute__((unused));

#ifdef USE_PAUSE
	int pause;
	/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
	 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
	 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
	 */
	//unsigned char save[PAUSE_H][PAUSE_W];
	unsigned char (*save)[PAUSE_W] = NULL/*x}*/;

	pause = 0;
	for(;;) {
#endif /*USE_PAUSE*/

#ifdef V_SCREEN
		{ /* vbuff(c)_def_vbuff()ϊ */
			unsigned char *dst, *src;
			dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
			src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
			for(x = DISP_X - 1; x >= 0; x--) {
				for(y = 0; y < DISP_Y; y++) {
					*dst = *src;
					dst += 1;      /* ʂEɑ܂ */
					src += DISP_X; /* cʂɑ܂ */
				}
				                            /* ʂ͊Ɏ̍sֈړĂ܂ */
				src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
			}
		}
#endif /*V_SCREEN*/
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
		joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
			       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
			| (joy & PAD_LF ? PAD_UP : 0)
			| (joy & PAD_RI ? PAD_DN : 0)
			| (joy & PAD_UP ? PAD_RI : 0)
			| (joy & PAD_DN ? PAD_LF : 0)
			| (joy & TRG_LF ? TRG_UP : 0)
			| (joy & TRG_RI ? TRG_DN : 0)
			| (joy & TRG_UP ? TRG_RI : 0)
			| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

#ifdef USE_PAUSE
		/* PAUSEB */
		if(joy & TRG_START) {
			pause = !pause;	/* PAUSEԐ؂ւ */
			if(pause) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
				if(save == NULL) DIE();
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
				free(save); /* C[Wޔpobt@J */
			}
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(pceTimerGetCount() % 1000 < 750) {
			render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
		} else {
			for(y = 0; y < PAUSE_H; y++) {
				for(x = 0; x < PAUSE_W; x++) {
					vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
				}
			}
		}
	}
#endif /*USE_PAUSE */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT

	now++;	/* O[o^C}XV */
}

/****************************************************************************
 *	delay
 ****************************************************************************/

void
delay(int frame)
{
	while(frame > 0) {
		schedule();
		frame--;
	}
}

/****************************************************************************
 *	demo_main
 ****************************************************************************/

static const char* const difficulty_msg[3][3]  = {
	{"  > ","   >","    "},
	{" <> ","<  >","    "},
	{" <㋉  ","< ㋉  ","  ㋉  "},
};
static const char* const qube_colors_msg[3][3]  = {
	{"  OF> ","  OF >","  OF  "},
	{" <lF> ","< lF >","  lF  "},
	{" <ܐF  ","< ܐF  ","  ܐF  "},
};
static const char* const hint_msg[2][3]  = {
	{" <  ","<   ","    "},
	{"  L> ","  L >","  L  "},
};

int
demo_main()
{
	int result;
	int i;
	int c;
	int x;
	int y;
	int sel = 0;

	for(;;) {
		schedule();

		/* X^[gHIH */
		if(joy & TRG_A) {
			result = 0;
			break;
		}
		if(joy & TRG_SELECT) {
			result = -1;
			break;
		}

		/* ՓxAL[u̐FAqg̗LIB */
		if((joy & TRG_UP) && (sel > 0)) {
			sel--;
		}
		if((joy & TRG_DN) && (sel < 2)) {
			sel++;
		}
		switch(sel) {
		case 0:
			if((joy & TRG_LF) && (difficulty > 0)) {
				difficulty--;
			}
			if((joy & TRG_RI) && (difficulty < 2)) {
				difficulty++;
			}
			break;
		case 1:
			if((joy & TRG_LF) && (qube_colors > 3)) {
				qube_colors--;
			}
			if((joy & TRG_RI) && (qube_colors < 5)) {
				qube_colors++;
			}
			break;
		case 2:
			if((joy & TRG_RI) && (hint > 0)) {
				hint--;
			}
			if((joy & TRG_LF) && (hint < 1)) {
				hint++;
			}
			break;
		default:
			DIE();
		}

		/* ^Cg\B */
		render.context->texture = &texture_table[3];
		render_object(&render, 0, 0, 0, 0, DISP_X, DISP_Y, 0);
		x = 61;
		y = 45;
		render_string_framed(&render, x + 16, y, "", 0x80, 0xfff);
		render_string_framed(&render, x +  8, y, "", 0x80, 0xfff);
		render_string_framed(&render, x +  0, y, "", 0x80, 0xfff);
		x--;
		y--;
		render_string_framed(&render, x + 16, y, "", 0x80, 0x992);
		render_string_framed(&render, x +  8, y, "", 0x80, 0x992);
		render_string_framed(&render, x +  0, y, "", 0x80, 0x992);

		/* XRA\B */
		x = 1;
		y = 1;
		render_printf_framed(&render, x, y, 0x82, 0x007, "1UP %05d", game.score);
		render_printf_framed(&render, x, y, 0x82, 0x00f, "1UP %5d",  game.score);
		x = DISP_X - 34;
		y = 1;
		render_printf_framed(&render, x, y, 0x82, 0x007,  "HI %05d", hiscore);
		render_printf_framed(&render, x, y, 0x82, 0x00f,  "HI %5d",  hiscore);

		/* ՓxAL[u̐FAqg̗L\B */
		x = 9;
		y = 70;
		if(sel == 0) {
			i = now % SEC(0.5) < SEC(0.25) ? 0 : 1;
			c = 0xff0;
		} else {
			i = 2;
			c = 0xff7;
		}
		render_printf_framed(&render, x, y, 0x80, c, "x%s", difficulty_msg[difficulty][i]);
		y += 12;
		if(sel == 1) {
			i = now % SEC(0.5) < SEC(0.25) ? 0 : 1;
			c = 0xff0;
		} else {
			i = 2;
			c = 0xff7;
		}
		render_printf_framed(&render, x, y, 0x80, c, "Lu%s", qube_colors_msg[qube_colors - 3][i]);
		y += 12;
		if(sel == 2) {
			i = now % SEC(0.5) < SEC(0.25) ? 0 : 1;
			c = 0xff0;
		} else {
			i = 2;
			c = 0xff7;
		}
		render_printf_framed(&render, x, y, 0x80, c, "qg%s", hint_msg[hint][i]);

		/* vvg\B */
		if(now % SEC(1) < SEC(0.75)) {
			x = (DISP_X - 4 * 8) / 2;
			y = DISP_Y - 16;
			render_string_framed(&render, x, y, " A START", 0x82, 0xff4);
			y += 8;
			render_string_framed(&render, x, y, "SEL EXIT", 0x82, 0xff4);
		}
	}

	return result;
}

/****************************************************************************
 *	game_main
 ****************************************************************************/

static void
game_init()
{
	/* ܂ANA܂B */
	memset(&game, 0, sizeof game);

	/* V[h܂B */
	game.seed = now;

	/* xݒ肵܂B */
	switch(difficulty) {
	case 0: game.level =  0; break; /*  */
	case 1: game.level = 20; break; /*  */
	case 2: game.level = 40; break; /* ㋉ */
	default: DIE();
	}

	/* BR}h */
	if((joy & PAD_UP) && (joy & PAD_A)) {
		int col;
		int row;
		for(row = FIELD_OUTR + 2; row < FIELD_ROWS; row++) {
			for(col = 0; col < FIELD_COLS; col++) {
				game.field[row][col].type = CELL_TYPE_QUBE1 + RND16_RANGE(game.seed, 0, QUBE_COLORS);
			}
		}
	}

	/* Q[JnNEXTL[u\̂߂ɁAړL[uĂ܂B
	 * ړL[u=NEXTL[uƂȂĂ̂ŁAxAgame_init()KvłB
	 */
	qube_init();
}

/* OɃL[uL1A0Ԃ܂B */
static int
outer_qube_test()
{
	int col;
	int row;
	CELL* cell;

	for(row = 0; row < FIELD_OUTR; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(cell->type) {
				return 1;
			}
		}
	}

	return 0;
}

/* ɋ󂫃Z1A0Ԃ܂B */
static int
inner_blank_test()
{
	int col;
	int row;
	CELL* cell;

	for(row = FIELD_OUTR; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->type) {
				return 1;
			}
		}
	}

	return 0;
}

void
game_main()
{
	int i;

	game_init();

	/* "START !!"\B */
	for(i = 0; i < SEC(2); i++) {
		if(joy & (TRG_A | TRG_B | TRG_DN)) {
			break;
		}
		field_disp();
		hint_disp();
		render_string_framed(&render, FIELD_X + 12, 58, "START !!", 0x80, 0x00f);
		schedule();
	}

	for(;;) {

		/* ړL[uOfBCB */
		for(i = 0; i < SEC(0.25/**/); i++) {
			field_disp();
			schedule();
		}

		/* ړL[u܂B */
		qube_init();

		/* [L[u}[N܂B */
		mark_top();

		/* qg}[N܂BȌ́Aqube_action()̒ōXV܂B */
		mark_hint();

		/* ړL[u𗎉܂B */
		for(;;) {
			if(!qube_action()) { /* ڒn`ڒ */
				break;
			}
			field_disp();
			hint_disp();
			qube_disp();
			schedule();
		}

		if(game.qube[0].type == CELL_TYPE_STAR) {

			if(erase_test()) {

				/* X^[ʕ\B */
				i = 0;
				for(;;) {
					field_disp();
					if(!trail_disp(i++)) {
						break;
					}
					schedule();
				}

				/* X^[ŁB */
				for(;;) {
					if(!erase_action()) { /* X^[Ŋ */
						break;
					}
					field_disp();
					schedule();
				}

			} else {

				/* X^[LZ{[iXB */
				add_score(756);
				i = 0;
				for(;;) {
					field_disp();
					if(!bonus_disp(i++)) {
						break;
					}
					schedule();
				}
			}

		} else {

			/* ړL[ủ܂B */
			qube_realize();

			/* Փ˃eXgs܂B
			 * ړL[üꂪĂꍇARsOɏՓ˃eXgs܂B(dl)
			 */
			if(hit_test()) {

				/* Փ˂AՓ˃ANVs܂B
				 * ړL[üꂪĂꍇARsOɏՓ˃ANVs܂B(dl)
				 */
				for(;;) {
					if(!hit_action()) { /* Փ˃ANV */
						break;
					}
					field_disp();
					schedule();
				}
			}

		}

		for(;;) {
			for(;;) {
				/* [L[ũ}[NXV܂B */
				mark_top();

				/* Rs܂B
				 * ̏ꍇAړL[üꕔĂꍇ̎RƂȂ܂B
				 * ڈȍ~̏ꍇÃL[ułĕL[u̎RƂȂ܂B
				 */
				for(;;) {
					if(!fall_action()) { /* R */
						break;
					}
					field_disp();
					schedule();
				}

				/* Փ˃eXgs܂B
				 * ̏ꍇAړL[üꕔꍇ̎RɂAՓ˃eXgƂȂ܂B
				 * ڈȍ~̏ꍇÃL[ułĕL[u̎RɂAՓ˃eXgƂȂ܂B
				 */
				if(hit_test()) {

					/* Փ˂AՓ˃ANVs܂B */
					for(;;) {
						if(!hit_action()) { /* Փ˃ANV */
							break;
						}
						field_disp();
						schedule();
					}
				}

				/* ŃeXgs܂B
				 * łȂ΁A芮łB
				 */
				if(!crush_test()) {
					break;
				}

				/* łAŃANVs܂B */
				for(;;) {
					if(!crush_action()) { /* ŃANV */
						break;
					}
					field_disp();
					schedule();
				}

				/* AJE^𑝂₵܂B */
				game.chain++;
			}

			/* OɃL[u΁A܂B */
			if(!outer_qube_test()) {
				break;
			}

			/* ɋ󂫃Z΁AQ[I[o[łB */
			if(!inner_blank_test()) {
				goto GAMEOVER;
			}

			/* 1Z̏OVtgJn܂B */
			shift_init();

			/* 1Z̏OVtg܂B */
			for(;;) {
				if(!shift_action()) { /* 1Z̏OVtg */
					break;
				}
				field_disp();
				schedule();
			}
		}

		/* jAA\܂BP̔jA0Ɛ܂B(dl) */
		if(game.chain) {
			msg_init(SEC(2), "CRUSH\n%5d\nCHAIN\n%5d", game.crush, game.chain - 1);
		}

		/* xJE^AQ[WJE^𑝂₵܂B */
		game.level_cnt++;
		game.gauge_cnt++;
	}

GAMEOVER:

	/* ̃L[uÂ܂B(O͂̂܂!!) */
	gameover_qube_init();
	for(;;) {
		if(!gameover_qube_action()) { /* SɈÂȂ */
			break;
		}
		field_disp();
		schedule();
	}

	/* "GAME OVER"\܂B */
	gameover_msg_init();
	for(;;) {
		if(!gameover_msg_action()) { /* \ */
			break;
		}
		field_disp();
		gameover_msg_disp();
		schedule();
	}
}

/****************************************************************************
 *	qube_speed
 ****************************************************************************/

fixed
qube_speed()
{
	int lev1;
	int lev2;
	fixed spd1;
	fixed spd2;
	fixed spd3;
	fixed spd4;

	lev1 = game.level / 20;
	lev2 = game.level % 20;

	spd1 = fimul(fld(0.20)/**/,  lev1     );
	spd2 = fimul(fld(0.02)/**/, (lev1 + 1));
	spd3 = fimul(spd2, lev2);
	spd4 = fadd(spd1, spd3);

	if(fcom(spd4, <, QUBE_SPEED_MIN)) {
		spd4 = QUBE_SPEED_MIN;
	}
	if(fcom(spd4, >, QUBE_SPEED_MAX)) {
		spd4 = QUBE_SPEED_MAX;
	}

	return spd4;
}

/****************************************************************************
 *	fall_speed
 ****************************************************************************/

int
fall_speed()
{
	int s;

	s = fist(fimul(QUBE_SPEED, CELL_H));
	if(s < FALL_SPEED_MIN) {
		s = FALL_SPEED_MIN;
	}
	if(s > FALL_SPEED_MAX) {
		s = FALL_SPEED_MAX;
	}

	return s;
}

/****************************************************************************
 *	add_score
 ****************************************************************************/

void
add_score(int pts)
{
	game.score += pts;
	if(game.score > 99999) {
		game.score = 99999;
	}
	if(game.score > hiscore) {
		hiscore = game.score;
	}
}

/****************************************************************************
 *	shift_init
 ****************************************************************************/

void
shift_init()
{
	int col;
	int row;
	CELL* cell;

	/* ݂̈̏VtgJn̂݁Aw\łB */
	if(game.initial_shift) {
		game.initial_shift = 0;
		if(joy & PAD_LF) {
			game.shift = 0;
		} else if(joy & PAD_RI) {
			game.shift = 1;
		} else {
			/* Vtg肵܂B(󔒃Zɋ߂) */
			int qube_lf;
			int qube_ri;
			int blank_lf;
			int blank_ri;
			/* OL[u̍[ */
			for(qube_lf = 0; qube_lf < FIELD_COLS - 1; qube_lf++) {
				if(game.field[FIELD_OUTR - 1][qube_lf].type) {
					break;
				}
			}
			/* OL[ủE[ */
			for(qube_ri = FIELD_COLS - 1; qube_ri > 0; qube_ri--) {
				if(game.field[FIELD_OUTR - 1][qube_ri].type) {
					break;
				}
			}
			/* OL[u̍[Ɉԋ߂Ȁ󔒃Z */
			for(blank_lf = qube_lf - 1; blank_lf >= 0; blank_lf--) {
				if(!game.field[FIELD_OUTR][blank_lf].type) {
					break;
				}
			}
			/* OL[ủE[Ɉԋ߂AȄ󔒃Z */
			for(blank_ri = qube_ri + 1; blank_ri <= FIELD_COLS - 1; blank_ri++) {
				if(!game.field[FIELD_OUTR][blank_ri].type) {
					break;
				}
			}
			if(blank_lf < 0) { /* ɋ󔒃Z */
				game.shift = 1;
			} else if(blank_ri > FIELD_COLS - 1) { /* Eɋ󔒃Z */				
				game.shift = 0;
			} else {
				if((qube_lf - blank_lf) <= (blank_ri - qube_ri)) { /* 󔒃Z߂I */
					game.shift = 0;
				} else {
					game.shift = 1;
				}
			}
		}
	}

	/* ÕL[uVtg̉ʒ[ɒBAIɕ]܂B */
	for(row = 0; row < FIELD_OUTR; row++) {
		cell = &game.field[row][game.shift ? FIELD_COLS - 1 : 0];
		if(cell->type) {
			game.shift = !game.shift;
			break;
		}
	}

	if(game.shift) {
		for(row = 0; row < FIELD_OUTR; row++) {
			memmove(&game.field[row][1], &game.field[row][0], sizeof(CELL) * (FIELD_COLS - 1));
			memset(&game.field[row][0], 0, sizeof(CELL));
		}
	} else {
		for(row = 0; row < FIELD_OUTR; row++) {
			memmove(&game.field[row][0], &game.field[row][1], sizeof(CELL) * (FIELD_COLS - 1));
			memset(&game.field[row][FIELD_COLS - 1], 0, sizeof(CELL));
		}
	}

	for(row = 0; row < FIELD_OUTR; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}
			cell->stat  = CELL_STAT_SHIFT;
			cell->count = CELL_W;
		}
	}
}

/****************************************************************************
 *	qube_init
 ****************************************************************************/

/* ړL[u܂B */
void
qube_init()
{
	unsigned char type[] = {
		CELL_TYPE_QUBE1,
		CELL_TYPE_QUBE2,
		CELL_TYPE_QUBE3,
		CELL_TYPE_QUBE4,
		CELL_TYPE_QUBE5,
	};
	int col;
	int row;
	CELL* cell;

	/* xAbvB */
	while(game.level_cnt >= LEVEL_CNT_MAX) {
		game.level_cnt -= LEVEL_CNT_MAX;
		if(game.level < 999) {
			game.level++;
		}
	}

	/* ONEXTL[uÄړL[uƂ܂B */
	memcpy(game.qube, game.next, sizeof(CELL) * 3);

	/* VNEXTL[uA܂́AX^[𐶐܂B */
	if(game.gauge_cnt >= GAUGE_CNT_MAX) {
		game.gauge_cnt -= GAUGE_CNT_MAX;
		game.next[0].type = CELL_TYPE_STAR;
		game.next[1].type = 0;
		game.next[2].type = 0;
	} else {
		//shuffle(type, QUBE_COLORS, sizeof *type, RND16(game.seed));
		//2005/11/06 21:35:00 shuffle()֐̎dlύXɒǏ]
		shuffle(type, QUBE_COLORS, sizeof *type, &game.seed);
		game.next[0].type = type[0];
		game.next[1].type = type[1];
		game.next[2].type = type[2];
	}

	/* BR}h */
	if((joy & PAD_UP) && (joy & PAD_B)) {
		game.next[0].type = CELL_TYPE_STAR;
		game.next[1].type = 0;
		game.next[2].type = 0;
	}

	/* Q[JnȂ΁AړL[u=NEXTL[uƂĂ܂B
	 * ŏ̈ړL[uo܂ł̊Ԃ́ANEXTL[u\̐̂߂łB
	 */
	if(!game.qube[0].type) {
		memcpy(game.qube, game.next, sizeof(CELL) * 3);
	}

	/* ړL[ủ]AʒuAԂȂǂ܂B */
	game.qube_rot   = 0;
	game.qube_col   = 3;
	game.qube_row   = 1;
	game.qube_pos   = fld(0.5);
	game.qube_stat  = QUBE_STAT_WAIT;
	game.qube_delay = QUBE_WAIT_DELAY;

	/* AJE^AjJE^Zbg܂B */
	game.chain = 0;
	game.crush = 0;

	/* ݂̈̏VtgJn̂݁Aw\łB */
	game.initial_shift = 1;

	/* ɂĈ񂾂AOVtg̕]\łB */
	game.shift_turn_ok = 1;

	/* ̋󂫃Z𐔂ċN܂B~bgC_ł̂߂łB */
	game.blank = 0;
	for(row = FIELD_OUTR; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->type) {
				game.blank++;
			}
		}
	}
}

/****************************************************************************
 *	qube_realize
 ****************************************************************************/

/* ړL[ủ܂B
 * ݂̈ړL[uX^[łꍇ́Å֐ĂяoĂ͂܂B
 */
void
qube_realize()
{
	int i;
	int col;
	int row;
	CELL* cell;

	/* ړL[ůeZɂ... */
	for(i = 0; i < 3; i++) {

		/* ̉tB[hʒu߂܂B */
		col = game.qube_col + qube_col_ofs[game.qube_rot][i];
		row = game.qube_row + qube_row_ofs[game.qube_rot][i];

		/* L[u̎ނƃtB[hʒumF܂B */
		if((game.qube[i].type < CELL_TYPE_QUBE1) ||
		   (game.qube[i].type > CELL_TYPE_QUBE5) ||
		   (col < 0) || (col > FIELD_COLS - 1) ||
		   (row < 0) || (row > FIELD_ROWS - 1)) {
			DIE();
		}

		/* L[ủ܂B */
		cell = &game.field[row][col];
		memset(cell, 0, sizeof(CELL));
		cell->type = game.qube[i].type;
	}
}

/****************************************************************************
 *	gameover_qube_init
 ****************************************************************************/

void
gameover_qube_init()
{
	int col;
	int row;
	int count;
	CELL* cell;

	/* ̃L[uォ珇ɈÂԂ̃ZbgAbvs܂B */
	count = 0;
	for(row = FIELD_OUTR/*dv*/; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}
			cell->stat  = CELL_STAT_GAMEOVER;
			cell->count = count;
		}
		count += SEC(0.1); /* gameover_qube_action()Ŗ񌸂炵āA0ɂȂÂ */
	}
}

/****************************************************************************
 *	msg_init
 ****************************************************************************/

void 
msg_init(int time, const char* fmt, ...)
{
	va_list ap;

	game.msg_cnt = 0;
	game.msg_time = time;

	va_start(ap, fmt);
	vsprintf(game.msg, fmt, ap);
	va_end(ap);
}

/****************************************************************************
 *	mark_top
 ****************************************************************************/

void
mark_top()
{
	int col;
	int row;
	CELL* cell;

	/* ʏԂŁAAɋ󂫃Z΁A[}[N܂B
	 * Ȃ΁A[}[N܂B
	 */
	for(row = 1/*dv*/; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}
			if(!cell->stat &&
			   !(cell - FIELD_COLS)->type) {
				cell->flag |=  CELL_FLAG_TOP;
			} else {
				cell->flag &= ~CELL_FLAG_TOP;
			}
		}
	}
}

/****************************************************************************
 *	mark_hint
 ****************************************************************************/

static void
mark_hint_sub(int col, int row, int type)
{
	int i;
	int j;
	CELL* cell;

	if((col < 0) || (col > FIELD_COLS - 1) ||
	   (row < 0) || (row > FIELD_ROWS - 1)) {
		return;
	}

	cell = &game.field[row][col];
	if((cell->type != type) || (cell->flag & CELL_FLAG_HINT)) {
		return;
	}
	cell->flag |= CELL_FLAG_HINT;

	for(i = -1; i <= 1; i++) {
		for(j = -1; j <= 1; j++) {
			mark_hint_sub(col + i, row + j, type);
		}
	}
}

void
mark_hint()
{
	int i;
	int j;
	int k;
	int col;
	int row;
	int type;
	CELL* cell;
	unsigned char type2x2[2][2];

	/* ܂Ã݂qgSď܂B */
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}
			cell->flag &= ~CELL_FLAG_HINT;
		}
	}

	/* ݂̈ړL[uX^[Ȃ΁A܂B */
	if(game.qube[0].type == CELL_TYPE_STAR) {
		return;
	}

	/* ړL[ủ]WJ܂B */
	memset(type2x2, 0, sizeof type2x2);
	for(i = 0; i < 3; i++) {
		col = qube_col_ofs[game.qube_rot][i] + 0/*colItZbg 0`1*/;
		row = qube_row_ofs[game.qube_rot][i] + 1/*rowItZbg-1`0*/;
		type2x2[row][col] = game.qube[i].type;
	}

	for(k = 0; k < 2; k++) {
		type = type2x2[1][k] ? : type2x2[0][k]; /* GCC Extension */
		col = game.qube_col + k;
		for(row = 1/*Ô*/; row < FIELD_ROWS; row++) {
			cell = &game.field[row][col];
			if(cell->type) {
				if(cell->type == type) {
					row--; /* ړubN̐ڒn`ڒs_Ƃ */
					for(i = -1; i <= 1; i++) {
						for(j = -1; j <= 1; j++) {
							mark_hint_sub(col + i, row + j, type);
						}
					}
				}
				break;
			}
		}
	}
}

/****************************************************************************
 *	move_test
 ****************************************************************************/

/* ړL[uAw肳ꂽʒuAw肳ꂽ]ňړ\A肵܂B
 * ړ\Ȃ΁A1Ԃ܂B
 * ړsȂ΁A0Ԃ܂B
 */
int
move_test(int qube_col, int qube_row, int qube_rot)
{
	int i;
	int col;
	int row;

	/* ړL[ůeZɂ... */
	for(i = 0; i < 3; i++) {
		if(!game.qube[i].type) {
			continue;
		}

		/* tB[ḧʒu߂܂B */
		col = qube_col + qube_col_ofs[qube_rot][i];
		row = qube_row + qube_row_ofs[qube_rot][i];

		/* tB[hOA܂́ÃL[uL΁AړsłB */
		if((col < 0) || (col > FIELD_COLS - 1) ||
		   (row < 0) || (row > FIELD_ROWS - 1) ||
		   game.field[row][col].type) {
			return 0; /* ړs */
		}
	}

	return 1; /* ړ\ */
}

/****************************************************************************
 *	hit_test
 ****************************************************************************/

static void
hit_test_sub(int col, int row, int type, int count)
{
	int i;
	int j;
	CELL* cell;

	if((col < 0) || (col > FIELD_COLS - 1) ||
	   (row < 0) || (row > FIELD_ROWS - 1)) {
		return;
	}

	cell = &game.field[row][col];
	if((cell->type != type) || (cell->stat)) {
		return;
	}
	cell->stat  = CELL_STAT_HIT;
	cell->count = count;

	/* _[WgyL[ûAƂƏ[L[ułĂA
	 * FԂĂȂ̂́A[L[ũ}[NĂ܂B
	 * FԂ[L[uɂAqbg}[N\邽߂łB
	 * row=0̃L[uCELL_FLAG_TOP}[N邱Ƃ͗L蓾ȂArow!=0͕̌svłB
	 */
	if(cell->flag & CELL_FLAG_TOP) {
		if((cell - FIELD_COLS)->type != type) {
			cell->flag &= ~CELL_FLAG_TOP;
		}
	}

	for(i = -1; i <= 1; i++) {
		for(j = -1; j <= 1; j++) {
			hit_test_sub(col + i, row + j, type, count);
		}
	}
}

int
hit_test()
{
	int count = 0;
	//
	int col;
	int row;
	CELL* cell;

	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}

			/* row=0̃L[uCELL_FLAG_TOP}[N邱Ƃ͗L蓾ȂArow!=0͕̌svłB */
			if(!cell->stat &&
			   (cell->flag & CELL_FLAG_TOP) &&
			   (cell->type == (cell - FIELD_COLS)->type)) {
				hit_test_sub(col, row, cell->type, count);
				count -= HIT_TIME;
			}
		}
	}

	return count;
}

/****************************************************************************
 *	crush_test
 ****************************************************************************/

int
crush_test()
{
	int result = 0;
	//
	int col;
	int row;
	CELL* cell;

	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}
			if(cell->stat == CELL_STAT_CRUSH) {
				add_score((game.chain + 1) * 10);
				game.crush++;
				result = 1;
			}
		}
	}

	return result;
}

/****************************************************************************
 *	erase_test
 ****************************************************************************/

int
erase_test()
{
	int col;
	int row;
	int type;
	CELL* cell;

	if(game.qube_row < FIELD_ROWS - 1) {
		type = game.field[game.qube_row + 1][game.qube_col].type;
		for(row = 0; row < FIELD_ROWS; row++) {
			for(col = 0; col < FIELD_COLS; col++) {
				cell = &game.field[row][col];
				if(cell->type == type) {
					cell->stat  = CELL_STAT_ERASE;
					cell->count = 0;
				}
			}
		}
		return 1;
	}

	return 0;
}

/****************************************************************************
 *	qube_action
 ****************************************************************************/

/* ړL[u𑀍삵܂B
 * ANVpȂ΁A1Ԃ܂B
 * ڒn`ڒA0Ԃ܂B
 */
int
qube_action()
{
	switch(game.qube_stat) {

	case QUBE_STAT_WAIT:

		game.qube_delay--;
		if((game.qube_delay <= 0) || (joy & PAD_DN)/*Jn*/) {
			game.qube_stat = QUBE_STAT_FALL;
		}

		break;

	case QUBE_STAT_FALL:

		if(joy & PAD_DN) {
			if(game.qube[0].type == CELL_TYPE_STAR) {
				game.qube_pos = fild(0); /*  */
			} else {
				if(ficom(QUBE_SPEED, <, 1)) {
					game.qube_pos = fild(0); /*  */
				} else {
					game.qube_pos = fsub(game.qube_pos, QUBE_SPEED);
				}
			}
		} else {
			if(game.qube[0].type == CELL_TYPE_STAR) {
				game.qube_pos = fsub(game.qube_pos, STAR_SPEED);
			} else {
				game.qube_pos = fsub(game.qube_pos, QUBE_SPEED);
			}
		}

		while(ficom(game.qube_pos, <=, 0)) {
			if(!move_test(game.qube_col, game.qube_row + 1, game.qube_rot)) { /* ڒn? */
				game.qube_pos   = fild(0);
				game.qube_stat  = QUBE_STAT_LAND;
				game.qube_delay = QUBE_LAND_DELAY;
				break;
			}
			game.qube_row++; /* ̃Z */
			game.qube_pos = fiadd(game.qube_pos, 1);
			if(joy & PAD_DN) {
				add_score(1);
			}
		}

		break;

	case QUBE_STAT_LAND:

		if(move_test(game.qube_col, game.qube_row + 1, game.qube_rot)) { /* ĊJ? */
			game.qube_stat = QUBE_STAT_FALL;
		} else {
			game.qube_delay--;
			if((game.qube_delay <= 0) || (joy & TRG_DN)/*ڒ*/) {
				return 0; /* ڒn`ڒ */
			}
		}

		break;

	default:
		DIE();
	}

	/* Eړ󂯕t܂B */
	if(joy & TRG_LF) {
		if(move_test(game.qube_col - 1, game.qube_row, game.qube_rot)) {
			game.qube_col--;
			mark_hint(); /* qgXV */
		}
	}
	if(joy & TRG_RI) {
		if(move_test(game.qube_col + 1, game.qube_row, game.qube_rot)) {
			game.qube_col++;
			mark_hint(); /* qgXV */
		}
	}

	/* X^[łȂ΁AE]󂯕t܂B */
	if(game.qube[0].type != CELL_TYPE_STAR) {
		if(joy & TRG_A) {
			if(move_test(game.qube_col, game.qube_row, (game.qube_rot + 1) & 3)) {
				game.qube_rot = (game.qube_rot + 1) & 3;
				mark_hint(); /* qgXV */
			}
		}
		if(joy & TRG_B) {
			if(move_test(game.qube_col, game.qube_row, (game.qube_rot - 1) & 3)) {
				game.qube_rot = (game.qube_rot - 1) & 3;
				mark_hint(); /* qgXV */
			}
		}
	}

	return 1; /* ANVp */
}

/****************************************************************************
 *	fall_action
 ****************************************************************************/

int
fall_action()
{
	int result = 0;
	//
	int col;
	int row;
	CELL* cell;

	for(row = FIELD_ROWS - 1; row >= 0; row--) {
		for(col = FIELD_COLS - 1; col >= 0; col--) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}

			switch(cell->stat) {

			case CELL_STAT_NORMAL:
				/* ɋ󂫃ZL... */
				if((row < FIELD_ROWS - 1) &&
				 !(cell + FIELD_COLS)->type) {
					/* ֑JڂÃZֈړ܂B */
					cell->stat  = CELL_STAT_FALL;
					cell->count = CELL_H;
					memcpy(cell + FIELD_COLS, cell,    sizeof(CELL));
					memset(                   cell, 0, sizeof(CELL));
					/* ANVp܂B */
					result = 1;
				}
				break;

			case CELL_STAT_FALL:
				/* 1Z... */
				cell->count -= FALL_SPEED;
				if(cell->count <= 0) {
					/* ɋ󂫃ZL... */
					if((row < FIELD_ROWS - 1) &&
					 !(cell + FIELD_COLS)->type) {
						/* pÃZֈړ܂B */
						cell->count += CELL_H;
						memcpy(cell + FIELD_COLS, cell,    sizeof(CELL));
						memset(                   cell, 0, sizeof(CELL));
						/* ANVp܂B */
						result = 1;
					/* ɋ󂫃Z... */
					} else {
						/* ʏԂ֑Jڂ܂B */
						cell->stat = CELL_STAT_NORMAL;
					}
				/* 1Z̓rȂ... */
				} else {
					/* ANVp܂B */
					result = 1;
				}
				break;
			}
		}
	}

	return result;
}

/****************************************************************************
 *	hit_action
 ****************************************************************************/

int
hit_action()
{
	int result = 0;
	//
	int col;
	int row;
	CELL* cell;

	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}
			if(cell->stat == CELL_STAT_HIT) {
				cell->count++;
				if(cell->count < HIT_TIME) {
					result = 1;
				} else {
					if(!(cell->flag & CELL_FLAG_DAMAGE)) {
						cell->stat  =  CELL_STAT_NORMAL;
						cell->flag |=  CELL_FLAG_DAMAGE;
						cell->flag &= ~CELL_FLAG_TOP;
					} else {
						cell->stat  = CELL_STAT_CRUSH;
						cell->count = 0;
					}
				}
			}
		}
	}

	return result;
}

/****************************************************************************
 *	crush_action
 ****************************************************************************/

int
crush_action()
{
	int result = 0;
	//
	int col;
	int row;
	CELL* cell;

	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}
			if(cell->stat == CELL_STAT_CRUSH) {
				cell->count++;
				if(cell->count < 7) {
					result = 1;
				} else {
					memset(cell, 0, sizeof(CELL));
				}
			}
		}
	}

	return result;
}

/****************************************************************************
 *	shift_action
 ****************************************************************************/

int
shift_action()
{
	int result = 0;
	//
	int col;
	int row;
	CELL* cell;

	/* ɂĈ񂾂AOVtg̕]\łB */
	if(game.shift_turn_ok) {
		if(game.shift) {
			if(joy & PAD_LF) { /* EVtg֕] */
				game.shift_turn_ok = 0;
				for(row = 0; row < FIELD_OUTR; row++) {
					memmove(&game.field[row][0], &game.field[row][1], sizeof(CELL) * (FIELD_COLS - 1));
					memset(&game.field[row][FIELD_COLS - 1], 0, sizeof(CELL));
				}
			}
		} else {
			if(joy & PAD_RI) { /* VtgE֕] */
				game.shift_turn_ok = 0;
				for(row = 0; row < FIELD_OUTR; row++) {
					memmove(&game.field[row][1], &game.field[row][0], sizeof(CELL) * (FIELD_COLS - 1));
					memset(&game.field[row][0], 0, sizeof(CELL));
				}
			}
		}
		if(!game.shift_turn_ok) { /* ] */
			game.shift = !game.shift;
			for(row = 0; row < FIELD_OUTR; row++) {
				for(col = 0; col < FIELD_COLS; col++) {
					cell = &game.field[row][col];
					if(!cell->type) {
						continue;
					}
					if(cell->stat == CELL_STAT_SHIFT) {
						cell->count = CELL_W - cell->count;
					}
				}
			}
		}
	}
					
	for(row = 0; row < FIELD_OUTR; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}
			if(cell->stat == CELL_STAT_SHIFT) {
				cell->count -= 2;
				if(cell->count <= 0) {
					cell->stat = CELL_STAT_NORMAL;
				} else {
					result = 1;
				}
			}
		}
	}

	return result;
}

/****************************************************************************
 *	erase_action
 ****************************************************************************/

int
erase_action()
{
	int result = 0;
	//
	int col;
	int row;
	CELL* cell;

	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}
			if(cell->stat == CELL_STAT_ERASE) {
				cell->count++;
				if((cell->count - 1) / 3 <= 3) {
					result = 1;
				} else {
					memset(cell, 0, sizeof(CELL));
				}
			}
		}
	}

	return result;
}

/****************************************************************************
 *	gameover_qube_action
 ****************************************************************************/

int
gameover_qube_action()
{
	int result = 0;
	//
	int col;
	int row;
	CELL* cell;

	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}
			if(cell->stat == CELL_STAT_GAMEOVER) {
				if(cell->count > 0) {
					cell->count--;
					result = 1;
				}
			}
		}
	}

	return result;
}

/****************************************************************************
 *	field_disp
 ****************************************************************************/

/* g`܂B */
static void
wave_disp()
{
#define H 7 /* g̍ */

#if 0	/*------------------------------------------------------------------*/

	static       fixed D[H] = { fld(1),fld(3),fld(1),fld(3),fld(1),fld(3),fld(1) }; /* g̈ʑ */
	static const fixed S[H] = { fld(0.01),fld(0.02),fld(0.05),fld(0.09),fld(0.14),fld(0.20),fld(0.27) }; /* g̑x   */
	static const fixed T[H] = { fld(1.50),fld(1.40),fld(1.30),fld(1.20),fld(1.10),fld(1.00),fld(0.90) }; /* g̎g */
	//
	int x;
	int y;
	fixed d;
	fixed s;
	fixed t;
	unsigned char* p;

	p = &vbuff[DISP_X * (DISP_Y - H)];
	for(y = 0; y < H; y++) {
		d = D[y];
		s = S[y];
		t = T[y];
		for(x = 0; x < DISP_X; x++) {
			*p++ = fist(fimul(fsin(d), 2)) + (y + 7/**/);
			d = fadd(d, t);
			if(fcom(d, >=, PI)) {
				d = fsub(d, PI2);
			}
		}
		D[y] = fadd(D[y], s);
		if(fcom(D[y], >=, PI)) {
			D[y] = fsub(D[y], PI2);
		}
	}

#else	/*------------------------------------------------------------------*/

	int y;

	for(y = 1; y <= H; y++) {
		render_rectangle_fill(&render, 0, DISP_Y - y, DISP_X, 1, 15 - y);
	}

#endif	/*------------------------------------------------------------------*/

#undef H
}

/* wiʐ^`܂B */
static void
photo_disp()
{
#define X	(FIELD_X + 1)			/* ʐ^ߗ̈̍[ */
#define Y	(FIELD_Y + CELL_H * FIELD_OUTR)	/* ʐ^ߗ̈̏[ */
#define W	(CELL_W * FIELD_COLS - 1)	/* ʐ^ߗ̈̕   */
#define H	(CELL_H * FIELD_INNR - 1)	/* ʐ^ߗ̈̍ */

	static fixed D;
	//
	int i;
	int x;
	int y;
	fixed d;

	render.context->texture = &texture_table[2];

	i = 0;
	d = D;
	for(y = 0; y < H; y++) {
		if(++i == 9) { /* g͕`ȗ */
			i = 0;
			continue;
		}
		x = fist(fimul(fsin(d), 2/**/));
		render_object(&render, X, Y + y, X + x, Y + y, W, 1, DRW_NOMAL);
		d = fadd(d, fld(0.1/**/));
		if(fcom(d, >=, PI)) {
			d = fsub(d, PI2);
		}
	}

	D = fadd(D, fld(0.1/**/));
	if(fcom(D, >=, PI)) {
		D = fsub(D, PI2);
	}

#undef X
#undef Y
#undef W
#undef H
}

/* X^[Q[V`܂B */
static void
gauge_disp(int cnt)
{
	static const unsigned char pos[GAUGE_MAX][2] = {
		{ 0,20},{ 1,20},{ 2,20},{ 3,20},{ 4,20},{ 5,20},{ 6,20},{ 7,20},{ 8,20},{ 9,20},
		{10,20},{10,19},{10,18},{10,17},{10,16},{10,15},{10,14},{10,13},{10,12},{10,11},
		{10,10},{10, 9},{10, 8},{10, 7},{10, 6},{10, 5},{10, 4},{10, 3},{10, 2},{10, 1},
		{10, 0},{ 9, 0},{ 8, 0},{ 7, 0},{ 6, 0},{ 5, 0},{ 4, 0},{ 3, 0},{ 2, 0},{ 1, 0},
		{ 0, 0},
	};
	static int C = 0;
	//
	int c = (C += 2/**/);
	int i;
	int cc;
	int xx;
	int yy;

	if(cnt >= GAUGE_MAX) {
		cnt = GAUGE_MAX;
	}

	for(i = 0; i < cnt; i++) {
		cc = ((c & 16) ? (c ^ 15) : c) & 15;
		xx = pos[i][0];
		yy = pos[i][1];
		render_point(&render, GAUGE_X + 10 - xx, GAUGE_Y + yy, cc);
		render_point(&render, GAUGE_X + 10 + xx, GAUGE_Y + yy, cc);
		if(cnt < GAUGE_MAX) {
			c -= 2/**/;
		}
	}
}

/* NEXTL[u`܂B */
static void
next_disp()
{
	static void qube_disp_sub(const CELL qube[/*3*/], int x0, int y0, int rot);
	//
	int x0;
	int y0;

	/* ubŇ_W߂܂B */
	x0 = NEXT_X;
	y0 = NEXT_Y + CELL_H;

	/* ړubNSɉʓɕ\܂ł́AړubN̕\ێ܂B
	 * ړubN\ĂԂ́A]Ǐ]܂B
	 */
	if(game.qube_row < 2) {
		if(game.qube[0].type == CELL_TYPE_STAR) {
			qube_disp_sub(game.qube, x0 + 5, y0 - 4, game.qube_rot);
			gauge_disp(GAUGE_MAX);
		} else {
			qube_disp_sub(game.qube, x0, y0, game.qube_rot);
			if(game.next[0].type == CELL_TYPE_STAR) {
				gauge_disp(GAUGE_MAX);
			} else {
				gauge_disp(GAUGE_MAX * game.gauge_cnt / GAUGE_CNT_MAX);
			}
		}
	} else {
		if(game.next[0].type == CELL_TYPE_STAR) {
			qube_disp_sub(game.next, x0 + 5, y0 - 4, 0);
			gauge_disp(GAUGE_MAX);
		} else {
			qube_disp_sub(game.next, x0, y0, 0);
			gauge_disp(GAUGE_MAX * game.gauge_cnt / GAUGE_CNT_MAX);
		}
	}
}

/* XRAAxȂǂ`܂B */
static void
info_disp()
{
	int len;
	char msg[64];

	render_printf(&render, HISCORE_X, HISCORE_Y, 0x82, 2, "%5d", hiscore   );
	render_printf(&render, SCORE_X,   SCORE_Y,   0x82, 2, "%5d", game.score);
	render_printf(&render, LEVEL_X,   LEVEL_Y,   0x80, 2, "%3d", game.level);

	len = strlen(game.msg);
	if(len > 63) {
		DIE();
	}
	if(game.msg_cnt < len) {
		len = game.msg_cnt++;
	} else {
		game.msg_time--;
	}
	memcpy(msg, game.msg, len);
	msg[len] = '\0';
	render_string(&render, MSG_X, MSG_Y, msg, 0x02, 2);
	if(game.msg_time <= 0) {
		msg_init(INT_MAX, "\nNOMAL\n GAME");
	}
}

//                     count   =   0 1 2 3 4 5 6 7 8 9
static const short shift_ptn[] = { 0,0,3,3,2,2,1,1,0,0 };
static const short shift_pos[] = { 0,0,2,2,4,4,7,7,9,9 };

static const unsigned char lline_color[16] = { 0,2,4,6,8,10,12,14,15,13,11,9,7,5,3,1 };

void
field_disp()
{
	int i;
	int x;
	int y;
	int col;
	int row;
	int sprno;
	CELL* cell;

	/* g`܂B */
	wave_disp();

	/* wiʐ^`܂B */
	photo_disp();

	/* tB[hg`܂B */
	render.context->texture = &texture_table[1];
	render_object(&render, 0, 0, 0, 0, DISP_X, DISP_Y - 7/*g*/, DRW_NOMAL);

	/* ̋󂫃ZsȉɂȂA~bgC_ł܂B */
	if(game.blank <= (FIELD_COLS * 2)) {
		render_rectangle_fill(&render, LLINE_X, LLINE_Y, LLINE_W, LLINE_H, lline_color[now % 16]);
	}

	/* NEXTL[u`܂B */
	next_disp();

	/* XRAAxȂǂ`܂B */
	info_disp();

	/* L[u`܂B */
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}

			x = FIELD_X + col * CELL_W;
			y = FIELD_Y + row * CELL_H;

			sprno = -1;

			switch(cell->stat) {

			case CELL_STAT_FALL:
				y -= cell->count;
				/* FALLTHRU */

			case CELL_STAT_NORMAL:
				sprno = PAT_QUBE_N[cell->type - CELL_TYPE_QUBE1][cell->flag & CELL_FLAG_DAMAGE];
				break;

			case CELL_STAT_HIT:
				if(!(cell->flag & CELL_FLAG_DAMAGE)) {
					if(cell->count < 0) {
						sprno = PAT_QUBE_N[cell->type - CELL_TYPE_QUBE1][0];
					} else {
						sprno = PAT_QUBE_N[cell->type - CELL_TYPE_QUBE1][1];
					}
				} else {
					if(cell->count < 0) {
						sprno = PAT_QUBE_N[cell->type - CELL_TYPE_QUBE1][1];
					} else if(cell->count < HIT_TIME) {
						sprno = PAT_QUBE_N[cell->type - CELL_TYPE_QUBE1][2];
					} else {
						sprno = PAT_QUBE_F[cell->type - CELL_TYPE_QUBE1][now & 1];
					}
				}
				break;

			case CELL_STAT_GAMEOVER:
				if(cell->count) {
					sprno = PAT_QUBE_N[cell->type - CELL_TYPE_QUBE1][cell->flag & CELL_FLAG_DAMAGE];
				} else {
					sprno = PAT_QUBE_G[cell->type - CELL_TYPE_QUBE1][cell->flag & CELL_FLAG_DAMAGE];
				}
				break;
			}

			if(sprno >= 0) {
				sprite_draw(x, y, sprno, 0);
			}
		}
	}

	/* ʒuωԂ̃L[úAʏ̃L[uOɕ`܂B */
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}

			x = FIELD_X + col * CELL_W;
			y = FIELD_Y + row * CELL_H;

			sprno = -1;

			switch(cell->stat) {

			case CELL_STAT_CRUSH:
				if(cell->count == 0) {
					sprno = PAT_QUBE_F[cell->type - CELL_TYPE_QUBE1][now & 1];
				} else if(cell->count <= 7) {
					sprno = PAT_QUBE_C[cell->type - CELL_TYPE_QUBE1][cell->count - 1];
					y += cell->count;
				}
				break;

			case CELL_STAT_ERASE:
				if(cell->count == 0) {
					sprno = PAT_QUBE_N[cell->type - CELL_TYPE_QUBE1][cell->flag & CELL_FLAG_DAMAGE];
				} else if((cell->count - 1) / 3 <= 3) {
					sprno = PAT_QUBE_E[cell->type - CELL_TYPE_QUBE1][(cell->count - 1) / 3];
					y -= cell->count;
				}
				break;

			case CELL_STAT_SHIFT:
				i = cell->count;
				if(i < 0) {
					i = 0;
				} else if(i > 9) {
					i = 9;
				}
				if(game.shift) {
					x -= shift_pos[i];
				} else {
					x += shift_pos[i];
					i = 9 - i;
				}
				sprno = PAT_QUBE_R[cell->type - CELL_TYPE_QUBE1][cell->flag & CELL_FLAG_DAMAGE][shift_ptn[i]];
				break;
			}

			if(sprno >= 0) {
				sprite_draw(x, y, sprno, 0);
			}
		}
	}

	/* _[Wg`܂B */
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}

			x = FIELD_X + col * CELL_W;
			y = FIELD_Y + row * CELL_H;

			if((cell->stat == CELL_STAT_HIT) &&
			   (cell->count >= 0) && (cell->count <= HIT_TIME - 1)) {
				sprno = PAT_DAMAGE[now % 4];
				sprite_draw(x, y, sprno, 0);
			}
		}
	}

	/* qbg}[N`܂B */
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}

			x = FIELD_X + col * CELL_W;
			y = FIELD_Y + row * CELL_H;

			if((cell->stat == CELL_STAT_HIT) && (cell->flag & CELL_FLAG_TOP)) {
				sprno = PAT_HIT[now % 2];
				sprite_draw(x, y, sprno, 0);
			}
		}
	}
}

/****************************************************************************
 *	hint_disp
 ****************************************************************************/

void
hint_disp()
{
	int x;
	int y;
	int col;
	int row;
	CELL* cell;

	if(!hint || (now & 2)) {
		return;
	}

	/* qgg`܂B */
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}

			x = FIELD_X + col * CELL_W;
			y = FIELD_Y + row * CELL_H;

			if(cell->flag & CELL_FLAG_HINT) {
				sprite_draw(x, y, SPR_HINT, 0);
			}
		}
	}
}

/****************************************************************************
 *	qube_disp
 ****************************************************************************/

static void
qube_disp_sub(const CELL qube[/*3*/], int x0, int y0, int rot)
{
	int i;
	int x;
	int y;
	int sprno;

	/* ړL[ůeZɂ... */
	for(i = 0; i < 3; i++, qube++) {
		if(!qube->type) {
			continue;
		}

		/* \W߂܂B */
		x = x0 + qube_col_ofs[rot][i] * CELL_W;
		y = y0 + qube_row_ofs[rot][i] * CELL_H;

		/* XvCgI܂B */
		switch(qube->type) {

		case CELL_TYPE_QUBE1 ... CELL_TYPE_QUBE5:
			sprno = PAT_QUBE_N[qube->type - CELL_TYPE_QUBE1][0];
			break;

		case CELL_TYPE_STAR:
			sprno = PAT_STAR[(now / 2) % 6];
			break;

		default:
			DIE();
		}

		/* XvCg`܂B */
		sprite_draw(x, y, sprno, 0);
	}
}

void
qube_disp()
{
	int x0;
	int y0;
	int i;
	int sprno;

	/* ubŇ_W߂܂B */
	x0 = FIELD_X +                      game.qube_col                 * CELL_W  ;
	y0 = FIELD_Y + fist(fimul(fsub(fild(game.qube_row), game.qube_pos), CELL_H));

	/* ړL[u`܂B */
	qube_disp_sub(game.qube, x0, y0, game.qube_rot);

	/* X^[łȂ΁AړL[ug`܂B */
	if(game.qube[0].type != CELL_TYPE_STAR) {
		i = now % SEC(2);
		if(i > 5) {
			i = 0;
		}
		sprno = PAT_MOVE[game.qube_rot][i];
		sprite_draw(x0, y0, sprno, 0);
	}
}

/****************************************************************************
 *	trail_disp
 ****************************************************************************/

int
trail_disp(int count)
{
	int result = 0;
	//
	int x;
	int y;
	int col;
	int row;
	int sprno;

	for(row = 0; row < (FIELD_ROWS + 2) * 2; row++) {
		sprno = count - row / 2;
		if((sprno < 0) || (sprno > 7)) {
			continue;
		}
		sprno = PAT_TRAIL[sprno];
		for(col = 0; col < FIELD_COLS; col++) {
			x = FIELD_X + col * CELL_W;
			y = FIELD_Y + row * CELL_H / 2;
			sprite_draw(x, y, sprno, 0);
		}
		result = 1;
	}

	return result;
}

/****************************************************************************
 *	bonus_disp
 ****************************************************************************/

int
bonus_disp(int count)
{
#define BONUS_X	(FIELD_X + 8)
#define BONUS_Y	65

	int y;

	if(count < 4) {
		y = BONUS_Y + (4          - count) * 16;
	} else if(count < 4 + SEC(1)) {
		y = BONUS_Y;
	} else {
		y = BONUS_Y + (4 + SEC(1) - count) * 16;
		if(y < -16) {
			return 0;
		}
	}

	render_string_framed(&render, BONUS_X     , y    , "765" , 0x81, 0x00f);
	render_string_framed(&render, BONUS_X + 26, y + 6, "Pts.", 0x80, 0x00f);

	return 1;

#undef BONUS_X
#undef BONUS_Y
}

/****************************************************************************
 *	gameover_msg_init, gameover_msg_action, gameover_msg_disp
 ****************************************************************************/

#define GAMEOVER_X (FIELD_X + 9)
#define GAMEOVER_Y 58

static const char gameover_msg[] = "GAME OVER";
static fixed gameover_d[9]; /* h */
static int   gameover_y[9]; /* ʒu */
static int   gameover_s[9]; /* 0 = oA1 = Î~A2 = ޏvA3 = ޏ */
static int   gameover_c;

void
gameover_msg_init()
{
	int i;
	int y;

	y = -10;
	for(i = 0; i < 9; i++) {
		gameover_d[i] = fidiv(PI_2, 2);
		gameover_y[i] = y;
		gameover_s[i] = 0;
		y -= 3;
	}
	gameover_c = 0;
}

int
gameover_msg_action()
{
	int result = 0;
	//
	int i;

	for(i = 0; i < 9; i++) {
		switch(gameover_s[i]) {

		case 0: /* o */
			gameover_y[i] += 5;
			if(gameover_y[i] >= GAMEOVER_Y) {
				gameover_y[i] = GAMEOVER_Y;
				gameover_s[i] = 1;
			}
			result = 1;
			break;

		case 1: /* Î~ */
			gameover_d[i] = fadd(gameover_d[i], fidiv(PI2, SEC(1)));
			while(fcom(gameover_d[i], >=, PI)) {
				gameover_d[i] = fsub(gameover_d[i], PI2);
			}
			if((i == 0) && ((joy & TRG_AB) || (gameover_c >= SEC(10)))) {
				gameover_s[i] = 2;
			}
			result = 1;
			break;

		case 2: /* ޏv */
			gameover_d[i] = fadd(gameover_d[i], fidiv(PI2, SEC(1)));
			if(fcom(gameover_d[i], >=, PI)) {
				gameover_d[i] = PI;
				gameover_s[i] = 3;
				if(i < 9 - 1) {
					gameover_s[i + 1] = 2;
				}
			}
			result = 1;
			break;

		case 3: /* ޏ */
			gameover_y[i] -= 5;
			if(gameover_y[i] > -10) {
				result = 1;
			}
			break;

		default:
			DIE();
		}
	}
	gameover_c++;

	return result;
}

void
gameover_msg_disp()
{
	int i;
	int x;
	int y;

	x = GAMEOVER_X;
	for(i = 0; i < 9; i++) {
		y = gameover_y[i] + fist(fimul(fsin(gameover_d[i]), 5));
		render_font_framed(&render, x, y, gameover_msg[i], 0x80, 0x00f);
		x += 5;
	}
}

#undef GAMEOVER_X
#undef GAMEOVER_Y
